/**
  ******************************************************************************
  * @file    vk1628_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1628_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk1628_driver.h"

/* extern variables ----------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1628_write_buf[16];
unsigned char vk1628_key[5];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*******************************************************************************
* Function Name  : VK1628_delay_nus
* Description    : ʱ1uS
* Input          : dur
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1628_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  :  VK1628_delayms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void  VK1628_delayms(unsigned long int n)
{
	while(n--)
	{
		 VK1628_delay_nus(1000);
	}
}

//GPIO ģI2C 
/*******************************************************************************
* Function Name  : VK1628Write1BytetoIC
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1628Write1BytetoIC(unsigned char data8)
{
	unsigned char i;
	
	VK1628_STB_LOW;			//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1628_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1628_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1628_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1628_delay_nus(200);
		VK1628_SLK_HIGH;	//ʱӵ
		VK1628_delay_nus(200);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ
}

/*******************************************************************************
* Function Name  : VK1628Read1BytefromIC
* Description    : ʱӵͨMCULEDIC1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1628Read1BytefromIC(void)
{
	unsigned char i,k=0;//iѭkʱ

	VK1628_DAT_HIGH;	//ͷDIOΪ
	VK1628_STB_LOW;	//֤STBΪ͵ƽ֮ǰ˿ڵ״̬
	for(i=0;i<8;i++)
	{
		VK1628_SLK_LOW;//ȽCLK
		VK1628_delay_nus(200);
		k=k>>1;
		if(VK1628_DIO_IO==0)
		{
			k=k&0x7f;			//DIOΪ͵ƽkλ塰0λֲ
		}
		else
		{
			k=(k|0x80)&0xff;//DIOΪߵƽkλá1λֲ
		}
		VK1628_SLK_HIGH;	//ʱӵ
		VK1628_delay_nus(200);
	}//һֽں˳ѭ
	
	return(k);//ض1ֽ	
}
/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1628_Disp_AutoAdd1Addr(unsigned char addr,unsigned char* databuf, unsigned char num)
{
	unsigned char i;//iƱҪٸֽʾ
	
	VK1628_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1628Write1BytetoIC(VK1628_DISPMODE_4G13S);//ʾģʽΪ134λʾģʽ
	VK1628_STB_HIGH;//ʾģʽ󽫡STB1
	VK1628Write1BytetoIC(VK1628_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1628_STB_HIGH;//ҪSTBá1
	VK1628Write1BytetoIC(VK1628_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1628Write1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1628_STB_HIGH;//еʾݺ14BYTE󣬽STBá1
	VK1628Write1BytetoIC(VK1628_DISP_ON|VK1628_PDUTY_12_16);//ʾ
	VK1628_STB_HIGH;//ʾ󽫡STBá1
}
/*******************************************************************************
* Function Name  : VK1628_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
void VK1628_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1628_STB_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1628Write1BytetoIC(VK1628_DISPMODE_4G13S);//ʾģʽΪ134λʾģʽ
	VK1628_STB_HIGH;//ʾģʽ󽫡STB1
	VK1628Write1BytetoIC(VK1628_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1628_STB_HIGH;//ҪSTBá1
	VK1628Write1BytetoIC(VK1628_STARTADDR+addr);//ʾݶӦĵַ
	//ַ󣬡STBΪ0Ҫʾ
	VK1628Write1BytetoIC(data8);//֡STB=01BYTEʾ
	VK1628_STB_HIGH;//ʾݺ󽫡STBá1
	VK1628Write1BytetoIC(VK1628_DISP_ON|VK1628_PDUTY_12_16);//ʾ
	VK1628_STB_HIGH;//ʾ󽫡STBá1
}
	
/*******************************************************************************
* Function Name  : KeyScan
* Description    : ɨ,ӵֽڿʼ
* Input          : disa
* Output         : None
* Return         : None
*******************************************************************************/
unsigned char VK1628_KeyScan(void)
{
	unsigned char i;
	
	VK1628_STB_HIGH;
	VK1628Write1BytetoIC(VK1628_CMD_READKEY);//Ϊ
	//STBΪ0ֵ
	//ļֵMCUļĴ
	//ICͺ˳ɶȶ
	for(i=0;i<5;i++)
	{
		vk1628_key[i]=VK1628Read1BytefromIC();
	}
	VK1628_STB_HIGH;
	
	return 0;//STBá1
}
/*******************************************************************************
* Function Name  : Vk1628_Init
* Description    : 1628ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1628_Init(void)    
{   
	GPIO_SetMode(VK1628_STB_PORT, VK1628_STB_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1628_CLK_PORT, VK1628_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1628_DIO_PORT, VK1628_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1628_STB_HIGH;                
	VK1628_SLK_HIGH;   
	VK1628_DAT_HIGH;
}  

/*******************************************************************************
* Function Name  : VK1628_Main
* Description    : VK1628Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1628_Main(void)
{   
	unsigned char i,j;
	
	VK1628_Init();
	 
	for(i=0;i<14;i++)
	{
		vk1628_write_buf[i]=0x00;
	}
	VK1628_Disp_AutoAdd1Addr(0,vk1628_write_buf,14);   //ȫ
	VK1628_delayms(1000); 
	while(1)
	{
		for(i=0;i<14;i++)
		{
			vk1628_write_buf[i]=0xff;
		}
		VK1628_Disp_AutoAdd1Addr(0,vk1628_write_buf,14);   //ȫ
		VK1628_delayms(1000); 
		for(i=0;i<14;i++)
		{
			vk1628_write_buf[i]=0x00;
		}
		VK1628_Disp_AutoAdd1Addr(0,vk1628_write_buf,14);   //ȫ
		VK1628_delayms(1000); 
		
		for(j=0;j<14;j++)
		{
			for(i=0;i<14;i++)
			{
				vk1628_write_buf[i]=0x00;
			}
			vk1628_write_buf[j]=0xff; //ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			VK1628_Disp_AutoAdd1Addr(0,vk1628_write_buf,14);   
			VK1628_delayms(500); 
		}
		for(j=0;j<8;j++)
		{
			for(i=0;i<14;i++)
			{
				vk1628_write_buf[i]=(1<<j); //ĳЩʾRAMֽڶӦһЩλΪգ޶ӦledֲʾRAM½
			}
			VK1628_Disp_AutoAdd1Addr(0,vk1628_write_buf,14);   
			VK1628_delayms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
