/**
  ******************************************************************************
  * @file    vk1628_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    07-01-2019
  * @brief   This file contains definitions for vk1628_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************  
  */
#ifndef __VK1628_DRIVER_H__
#define __VK1628_DRIVER_H__

#include "M451Series.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define 	VK1628_STB_PIN   BIT6
#define 	VK1628_STB_PORT  PD
#define 	VK1628_STB_IO    PD6

#define 	VK1628_CLK_PIN   BIT0
#define 	VK1628_CLK_PORT  PA
#define 	VK1628_CLK_IO    PA0

#define 	VK1628_DIO_PIN   BIT1
#define 	VK1628_DIO_PORT  PD
#define 	VK1628_DIO_IO    PD1

#define   VK1628_STB_HIGH     VK1628_STB_IO = 1  
#define   VK1628_STB_LOW      VK1628_STB_IO = 0  

#define   VK1628_SLK_HIGH     VK1628_CLK_IO = 1  
#define   VK1628_SLK_LOW      VK1628_CLK_IO = 0  
  
#define   VK1628_DAT_HIGH     VK1628_DIO_IO = 1  
#define   VK1628_DAT_LOW      VK1628_DIO_IO = 0   
 

#define   VK1628_STARTADDR					0XC0 

#define   VK1628_DISPMODE_4G13S     0x00 
#define   VK1628_DISPMODE_5G12S     0x01 
#define   VK1628_DISPMODE_6G11S     0x02 
#define   VK1628_DISPMODE_7G10S     0x03  

#define   VK1628_WRDTA_AUTOADD1ADDR 0x40  
#define   VK1628_WRDTA_FIXEDADDR   	0x44   
#define   VK1628_CMD_READKEY     		0x42  

#define 	VK1628_DISP_ON        		0X88  //ʾ
#define 	VK1628_DISP_OFF		   			0x80  //ʾ  
/*0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f ֱӦ
1/16,  2/16,  4/16,  10/16, 11/16, 12/16, 13/16, 14/16  */ 
#define 	VK1628_PDUTY_1_16      0X80  //ʾΪ1/16  
#define 	VK1628_PDUTY_2_16      0X81  //ʾΪ2/16  
#define 	VK1628_PDUTY_4_16      0X82  //ʾΪ4/16  
#define 	VK1628_PDUTY_10_16     0X83  //ʾΪ10/16  
#define 	VK1628_PDUTY_11_16     0X84  //ʾΪ11/16  
#define 	VK1628_PDUTY_12_16     0X85  //ʾΪ12/16  
#define 	VK1628_PDUTY_13_16     0X86  //ʾΪ13/16  
#define 	VK1628_PDUTY_14_16     0X87  //ʾΪ14/16  
 
/* Exported functions ------------------------------------------------------- */
void VK1628_Init(void);  
void VK1628_Disp_Set(void);
void VK1628_Disp_AutoAdd1Addr(uint8_t addr,uint8_t* databuf, uint8_t num);
void VK1628_Disp_FixedAddr(uint8_t addr, uint8_t data8);
void  VK1628_Main(void);
#endif  /*__VK1628_DRIVER_H__*/

/************************END OF FILE****/
